/*-
 * %%----------------------------------------------------------------------------------------------
 * Solidify Framework - Solidify Controller - ReadOnlyControllerWithOracleDbTest.java
 * SPDX-License-Identifier: GPL-2.0-or-later
 * %----------------------------------------------------------------------------------------------%
 * Copyright (C) 2017 - 2022 University of Geneva
 * %----------------------------------------------------------------------------------------------%
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as
 * published by the Free Software Foundation, either version 2 of the
 * License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public
 * License along with this program.  If not, see
 * <http://www.gnu.org/licenses/gpl-2.0.html>.
 * ----------------------------------------------------------------------------------------------%%
 */

package ch.unige.solidify.oracle.test;

import static org.hamcrest.CoreMatchers.is;
import static org.springframework.test.web.servlet.request.MockMvcRequestBuilders.get;
import static org.springframework.test.web.servlet.result.MockMvcResultMatchers.content;
import static org.springframework.test.web.servlet.result.MockMvcResultMatchers.jsonPath;
import static org.springframework.test.web.servlet.result.MockMvcResultMatchers.status;

import org.junit.jupiter.api.Disabled;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.autoconfigure.web.servlet.AutoConfigureMockMvc;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit.jupiter.SpringExtension;
import org.springframework.test.web.servlet.MockMvc;

import ch.unige.solidify.oracle.test.web.TestConfigApplication;

@Disabled("Oracle not always present")
@ExtendWith(SpringExtension.class)
@AutoConfigureMockMvc
@SpringBootTest(classes = TestConfigApplication.class)
class ReadOnlyControllerWithOracleDbTest {

  @Autowired
  private MockMvc mockMvc;

  @Test
  void testGetSearchWithOracleContains() throws Exception {
    this.mockMvc.perform(get("/oraTest/search?search=namesForSearch¢%RAOLI% WITHIN PRENOMS"))
            .andExpect(status().isOk())
            .andExpect(content().contentType("application/hal+json"))
            // .andDo(print());
            .andExpect(jsonPath("_data[0].entityId", is("514425")));
  }

  @Test
  void testGetSearchWithOracleContainsMix() throws Exception {
    this.mockMvc.perform(get("/oraTest/search?search=lastname:WANG,namesForSearch¢RAOLI WITHIN PRENOMS"))
            .andExpect(status().isOk())
            .andExpect(content().contentType("application/hal+json"))
            // .andDo(print());
            .andExpect(jsonPath("_data[0].entityId", is("514425")));
  }
}
